﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Text.RegularExpressions;

// The word file used by this program is the file
// 6of12.txt from the 12Dicts package available at:
//
// http://wordlist.sourceforge.net

namespace howto_select_long_words
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Select words that have the given minimum length.
        private void btnSelect_Click(object sender, EventArgs e)
        {
                // Remove non-alphabetic characters at the ends of words.
                Regex end_regex = new Regex("[^a-zA-Z]+$");
                string[] all_lines = File.ReadAllLines("6of12.txt");
                var end_query =
                    from string word in all_lines
                    select end_regex.Replace(word, "");

                // Remove words that still contain non-alphabetic characters.
                Regex middle_regex = new Regex("[^a-zA-Z]");
                var middle_query =
                    from string word in end_query
                    where !middle_regex.IsMatch(word)
                    select word;

                // Make a query to select lines of the desired length.
                int min_length = (int)nudMinLength.Value;
                int max_length = (int)nudMaxLength.Value;
                var length_query =
                    from string word in middle_query
                    where (word.Length >= min_length) &&
                          (word.Length <= max_length)
                    select word;

            // Write the selected lines into a new file.
            string[] selected_lines = length_query.ToArray();
            File.WriteAllLines("Words.txt", selected_lines);

            MessageBox.Show("Selected " + selected_lines.Length +
                " words out of " + all_lines.Length + ".");
        }
    }
}
